#property copyright "Copyright 2016, Zoltan Tarsoly"
#property link "tarsoly.zoltan.sandor@gmail.com"

#include <stdlib.mqh>

extern int magic_number = 1234;
extern double Lots=0.1;
extern int shift = 4;
extern int YMAPeriod=1800;
int init() {
  return(0);
}

int deinit() {
  return(0);
}

int start() {
  int i;
  int order_type;
  double open_price;
  double stop_loss_price;
  double take_profit_price;
  double v1[];
  double v2[];
  double v3[];
  double v4[];
  double val1;
  double val2;
  double buy[];
  double sell[];
  string symbol = Symbol();
  ArrayResize(v1, Bars);
  ArrayResize(v2, Bars);
  ArrayResize(v3, Bars);
  ArrayResize(v4, Bars);
  ArrayResize(buy, Bars);
  ArrayResize(sell, Bars);
  ArrayInitialize(v1, 0);
  ArrayInitialize(v2, 0);
  ArrayInitialize(v3, 0);
  ArrayInitialize(v4, 0);
  ArrayInitialize(buy, 0);
  ArrayInitialize(sell, 0);
  for (i = Bars - 1; i >= 0; i--) {
    val1 = iFractals(NULL, 0, MODE_UPPER, i + 2);
    if (val1 > 0)
      v1[i] = High[i + 2];
    else
      v1[i] = v1[i + 1];
    val2 = iFractals(NULL, 0, MODE_LOWER, i + 2);
    if (val2 > 0)
      v2[i] = Low[i + 2];
    else
      v2[i] = v2[i + 1];
    if ((High[i] > v1[i]) || (High[i + 1] > v1[i + 1]) || (High[i + 2] > v1[i + 2]) || (High[i + 3] > v1[i + 3]) || (High[i + 4] > v1[i + 4]))
      v3[i - 1] = v1[i]; //felesleges a shift, csak sszezavarja az rtkeket, majd az order-nl eltolod
    else
      v3[i - 1] = 0;
    if ((Low[i] < v2[i]) || (Low[i + 1] < v2[i + 1]) || (Low[i + 2] < v2[i + 2]) || (Low[i + 3] < v2[i + 3]) || (Low[i + 4] < v2[i + 4]))
      v4[i - 1] = v2[i]; //felesleges a shift, csak sszezavarja az rtkeket, majd az order-nl eltolod
    else
      v4[i - 1] = 1000;
  }
  for (i = Bars - 1; i >= 0; i --) {
    if (((Low[i + 2] < v2[i + 2]) || (Low[i + 1] < v2[i + 1]) || (Low[i] < v2[i])) && ((v4[i] == v4[i + 1]) && ((v4[i+1]<1000 && v4[i]<1000 && Low[i+1]<v2[i] && Low[i+1]<Low[i] && High[i+2]<High[i+1]))) && iClose(Symbol(),0,1)>iMA(Symbol(),0,YMAPeriod,0,MODE_SMA,PRICE_OPEN,0)) // ebben a sorban volt a gond, egy Close[i] >= v4[i]
      buy[i] = v4[i]; //felesleges a shift, csak sszezavarja az rtkeket, majd az order-nl eltolod
    if (((High[i + 2] > v1[i + 2]) || (High[i + 1] > v1[i + 1]) || (High[i] > v1[i])) && ((v3[i] == v3[i + 1]) && ((v3[i+1]>0 && v3[i]>0 && High[i+1]>v1[i] && High[i+1]>High[i] && Low[i+2]<Low[i+1]))) && iClose(Symbol(),0,1)<iMA(Symbol(),0,YMAPeriod,0,MODE_SMA,PRICE_OPEN,0)) // ebben a sorban volt a gond, egy Close[i] <= v3[i]
      sell[i] = v3[i]; //felesleges a shift, csak sszezavarja az rtkeket, majd az order-nl eltolod
  }
  // Long position
  if ((buy[0] > 0) && (buy[0] > Close[0])) { // nyitunk, ha jelzs van s van rtelme Buy Stop-nak
    open_price = NormalizeDouble(buy[0] + (shift * Point), Digits);
    stop_loss_price = NormalizeDouble(open_price - (30 * Point), Digits);
    take_profit_price = NormalizeDouble(open_price + (15 * Point), Digits);
 //   Print("Buy: " + v1[0] + " " + v2[0] + " " + v3[0] + " " + v4[0] + " " + buy[0] + " " + sell[0] + " " + open_price + " " + stop_loss_price + " " + take_profit_price);
    for (i = OrdersTotal() - 1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS))
        if (OrderMagicNumber() == magic_number) {
          order_type = OrderType();
          if (order_type == ORDER_TYPE_BUY_STOP) {
            if ((NormalizeDouble(OrderOpenPrice(), Digits) != open_price) || (NormalizeDouble(OrderStopLoss(), Digits) != stop_loss_price) || (NormalizeDouble(OrderTakeProfit(), Digits) != take_profit_price)) {
              if (!OrderModify(OrderTicket(), open_price, stop_loss_price, take_profit_price, OrderExpiration()))
                Print("Error: ", ErrorDescription(_LastError));
            }
            break;
          }
          else if (order_type == ORDER_TYPE_BUY)
            break;
        }
    if (i < 0)
      if (OrderSend(symbol, OP_BUYSTOP, Lots, open_price, 3, stop_loss_price, take_profit_price, NULL, magic_number,1) < 0)
        Print("Error: ", ErrorDescription(_LastError));
  }
  else
    for (i = OrdersTotal() - 1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS))
        if (OrderMagicNumber() == magic_number)
          if (OrderType() == ORDER_TYPE_BUY_STOP)
            if (!OrderDelete(OrderTicket()))
              Print("Error: ", ErrorDescription(_LastError));
  // Short Position
  if ((sell[0] > 0) && (sell[0] < Close[0])) { // nyitunk, ha jelzs van s van rtelme Sell Stop-nak
    open_price = NormalizeDouble(sell[0]- (shift * Point), Digits);
    stop_loss_price = NormalizeDouble(open_price + (30 * Point), Digits);
    take_profit_price = NormalizeDouble(open_price - (15 * Point), Digits);
 //   Print("Sell: " + v1[0] + " " + v2[0] + " " + v3[0] + " " + v4[0] + " " + buy[0] + " " + sell[0] + " " + open_price + " " + stop_loss_price + " " + take_profit_price);
    for (i = OrdersTotal() - 1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS))
        if (OrderMagicNumber() == magic_number) {
          order_type = OrderType();
          if (order_type == ORDER_TYPE_SELL_STOP) {
            if ((NormalizeDouble(OrderOpenPrice(), Digits) != open_price) || (NormalizeDouble(OrderStopLoss(), Digits) != stop_loss_price) || (NormalizeDouble(OrderTakeProfit(), Digits) != take_profit_price)) {
              if (!OrderModify(OrderTicket(), open_price, stop_loss_price, take_profit_price, OrderExpiration()))
                Print("Error: ", ErrorDescription(_LastError));
            }
            break;
          }
          else if (order_type == ORDER_TYPE_SELL)
            break;
        }
    if (i < 0)
      if (OrderSend(symbol, OP_SELLSTOP, Lots, open_price, 3, stop_loss_price, take_profit_price, NULL, magic_number,1) < 0)
        Print("Error: ", ErrorDescription(_LastError));
  }
  else
    for (i = OrdersTotal() - 1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS))
        if (OrderMagicNumber() == magic_number)
          if (OrderType() == ORDER_TYPE_SELL_STOP)
            if (!OrderDelete(OrderTicket()))
              Print("Error: ", ErrorDescription(_LastError));
  return(0);
}